/* xatopi - test harness for atopi function */
#include "local.h"
#define MINIMAL_WRITE(f) /* write nothing; empty file ok for semaphore */
void fixstr(char *);
main()
	{
	int i;		/* which case {0:N} */
	int ret;	/* returned value from atopi */
	char source[80];	/* source string for atopi */
	char desc[80];		/* description of test case */
	int expect;		/* expected result */
	bool was_ok = YES;	/* successful test? */
	FILE *fin;		/* input file with test cases */
	FILE *fout;		/* output file for "ok" */
	int nread;		/* number of input items read */

	fin = fopen("atopi.in", "r");
	if (fin == NULL)
		error("can't open", "atopi.in");
	while (getc(fin) != '\n')
		;
	while (getc(fin) != '\n')
		;
	FOREVER
		{
		nread = fscanf(fin,
			"%s %d %[^\n]",
			source, &expect, desc);
		if (nread == EOF)
			break;
		else if (nread != 3)
			error("bad input at or after source =", source);
		fixstr(source);
		ret = atopi(source);
		if (ret != expect)
			{
			printf("Failed case: <%s>: ", desc);
			printf("source=<%s>, ret=<%d>\n", source, ret);
			was_ok = NO;
			}
		}
	if (was_ok)
		{
		fout = fopen("atopi.ok", "w");
		MINIMAL_WRITE(fout);
		fclose(fout);
		exit(SUCCEED);
		}
	else
		exit(FAIL);
	}
